$RulesPlus::DefaultRuleFile = "config/server/rules.txt";

function fileManualCopy(%from, %to)
{
	%read = new FileObject();
	%read.openForRead(%from);	
	%write = new FileObject();
	%write.openForWrite(%to);
	while(!%read.isEOF())
		%write.writeLine(%read.readLine());
	%write.close();
	%write.delete();
	%read.close();
	%read.delete();
}

if(!isFile($RulesPlus::DefaultRuleFile))
	writeDefaultRuleFile(expandFileName("./defaultRules.txt"), $RulesPlus::DefaultRuleFile);

function loadRulesFromFile(%file)
{
	if(!isFile(%file))
	{
		error("ERROR: Rules file not found:" SPC %file);
		return;
	}
	%read = new FileObject();
	%read.openForRead(%file);
	if(%read.isEOF())
		return;
	$RulesPlus::Title = %read.readLine();
	$RulesPlus::Body = "";
	while(!%read.isEOF())
		$RulesPlus::Body = $RulesPlus::Body NL %read.readLine();
	$RulesPlus::Body = trim($RulesPlus::Body) @ "\n\n<font:Arial Bold:14>DO YOU AGREE TO THESE RULES?";
}

//Make sure the function exists so that we can package it properly
if(!isFunction("serverCmdMessageBoxNo"))
	eval("function serverCmdMessageBoxNo(%client) { }");

package RulesPlus
{
	function onMissionLoaded()
	{
		if($gameModeArg $= "")
			loadRulesFromFile($RulesPlus::DefaultRuleFile);
		else
		{
			%file = filePath($gameModeArg) @ "/rules.txt";
			if(isFile(%file))
				loadRulesFromFile(%file);
			else
				loadRulesFromFile($RulesPlus::DefaultRuleFile);
		}
		parent::onMissionLoaded();
	}
	function GameConnection::OnClientEnterGame(%this)
	{
		if(%this.rulesSent || %this.getClassName() !$= "GameConnection")
			return parent::onClientEnterGame(%this);
		else
			%this.sendRules();
	}

	function GameConnection::sendRules(%this)
	{
		%this.rulesSent = true;
		commandToClient(%this, 'MessageBoxYesNo', $RulesPlus::Title, $RulesPlus::Body, 'rulesAccept');
	}

	function serverCmdMessageBoxNo(%client)
	{
		parent::serverCmdMessageBoxNo(%client);
		if(%client.rulesSent)
		{
			echo(%client.getSimpleName() SPC "does not agree with the rules!");
			%client.delete("You must agree to the rules before you can play.");
		}
	}
};
activatePackage(RulesPlus);

function serverCmdRules(%client)
{
	%client.sendRules();
}

function serverCmdRulesAccept(%client)
{
	if(!%client.hasSpawnedOnce && %client.rulesSent)
		%client.onClientEnterGame();
	%client.rulesSent = false;
}

function serverCmdRulesAll(%client)
{
	if(%client.isSuperAdmin)
	for(%c = 0; %c < ClientGroup.getCount(); %c++)
		ClientGroup.getObject(%c).sendRules();
}

function serverCmdReloadRules(%client)
{
	if(%client.isSuperAdmin)
	loadRuleFile();
}